function z=zero_crossings(x,pts,level)
% call zero_cx(x,pts)
%      x - input vector whose zero crossings are to be determined
%      returns the zero crossing points
%      pts - number of points per interval
% Author: Petar Pepeljugoski




if nargin<3
    level=0;
end;

m=max(size(x));
x=x(:);
size(x);
NN=pts;
count=0;
k=1;
x=x-level;
z=[];

% use brute force, not elegant but it works the best
while (k<m-pts),
    
    if (x(k) * x(k+pts/NN)>0),
       k=k+pts/NN;
    else 
       if (x(k)*x(k+pts/NN)==0),
          if (x(k)==0)
             ind=k;
             k=k+pts/NN;
          end;
          if (x(k+pts/NN)==0),
             ind=k+pts/NN;
             k=k+pts/NN;
          end;
       else
          ctr=1;
          while (x(k)*x(k+1)>0)
             k=k+1;
          end;
          ind=k;
          k=k+pts/NN;
       end;
       count=count+1;
       z(count)=ind;    
    end;
end;




% n=max(size(z));


